/*------------------------------------------------------------------------------
--  This file is a part of the SocExplorer Software
--  Copyright (C) 2014, Plasma Physics Laboratory - CNRS
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-------------------------------------------------------------------------------*/
/*--                  Author : Alexis Jeandet
--                     Mail : alexis.jeandet@member.fsf.org
----------------------------------------------------------------------------*/
#ifndef ABSTRACTSPWBRIDGE_H
#define ABSTRACTSPWBRIDGE_H

#include <QObject>
#include <socexplorerplugin.h>
#define RMAP_MAX_XFER_SIZE 4000 //slightly less than 16kBytes
#include <spw.h>

class abstractSpwBridge : public QObject
{
    Q_OBJECT
public:
    explicit abstractSpwBridge(socexplorerplugin *parent);
    ~abstractSpwBridge();
    QWidget *getGUI();

public slots:
    virtual bool connectBridge();
    virtual bool disconnectBridge();
    virtual unsigned int Write(unsigned int *Value,unsigned int count, unsigned int address=0)=0;
    virtual unsigned int Read(unsigned int *Value,unsigned int count, unsigned int address=0)=0;
    virtual int pushRMAPPacket(char* packet,int size)=0;
signals:
    void setConnected(bool connected);
    void pushPacketOverTCP(char* packet,int size);
protected:
    socexplorerplugin* plugin;
    QWidget* p_GUI;
private:

};

#endif // ABSTRACTSPWBRIDGE_H
